rem Aplicacion: AppInstaller1.0
rem Autor: Sheldon
rem e-mail: sheldon@atomosybits.com

Option explicit

Dim fso, f, fc, fd, DIR, SDK, f1, f2, oshell, comando, cont, cont2
Dim NombreApli, NombreFolder, NombreCompleto, Opcion, NumAplis, Porcentaje
Dim file ,linea, archivo, Failure, Success, YaExisten, i, VISIBLE, ventana

REM ********************
REM * PARAMETROS:      *
REM ********************
DIR="Apps"
SDK="D:\Android\SDK\platform-tools"
rem VISIBLE="SI"//VISIBLE="NO"
VISIBLE="NO"


REM ********************
REM * CODIGO           *
REM ********************

set oshell=createobject("WScript.shell")
Set fso = CreateObject("Scripting.FileSystemObject")
cont = 0
cont2=0
Opcion = 0
Success = 0
Failure = 0
YaExisten = 0


If VISIBLE="SI" Then
	ventana=8
Else
	If VISIBLE="NO" Then
		ventana=0
	End If
End If


rem	Arrancamos el demonio adb y comprobamos que haya un dispositivo conectado?
comando= oshell.run("cmd /C "& SDK &"\adb devices", 0, true)
comando= oshell.run("cmd /C "& SDK &"\adb devices > bin\resultado.txt", 0, true)
set file= fso.OpenTextFile("bin\resultado.txt", 1)
rem	Leemos la 2 linea del fichero buscando dispositivos conectados
For i=0 to 1
	archivo = file.Readline
next
file.close
rem set file= fso.GetFile("bin\resultado.txt")
rem file.Delete


rem	Solo ejecutamos el codigo si hay algun dispostivo conectado
If (InStr(archivo, "device")) then

	Set f = fso.GetFolder(DIR)
	Set fc = f.Files
	Set fd = f.subFolders
	NumAplis = f.Files.count
 
	wscript.StdOut.write VbNewLine & VbTab &"=====================================================" & VbNewLine
       	wscript.StdOut.write VbTab &		"=                                                   =" & VbNewLine
	wscript.StdOut.write VbTab &		"=          Bienvenido al AppInstaller 1.0           =" & VbNewLine
	wscript.StdOut.write VbTab &		"=                                                   =" & VbNewLine
	wscript.StdOut.write VbTab &		"=   by: Sheldon   e-mail: sheldon@atomosybits.com   =" & VbNewLine
	wscript.StdOut.write VbTab &		"=                                                   =" & VbNewLine
	wscript.StdOut.write VbTab &		"=====================================================" & VbNewLine & VbNewLine
	wscript.StdOut.write "Que desea hacer? Seleccione una opcin:" & VbNewLine & VbNewLine
	wscript.StdOut.write "RESTAURAR:"& VbNewLine
	wscript.StdOut.write VbTab&"1. Instalar aplicaciones. (Hay "& NumAplis &" aplicaciones en la carpeta Apps)"& VbNewLine
	wscript.StdOut.write VbTab&"2. Restaurar datos." & VbNewLine
	wscript.StdOut.write VbTab&"3. Instalar aplicaciones y restaurar sus datos." & VbNewLine & VbNewLine

	While (Opcion < 1) or (Opcion > 3)
		wscript.StdOut.write "Introduzca la opcion deseada: "
		Opcion = Wscript.StdIn.ReadLine
	Wend

	wscript.StdOut.write VbNewLine

	If  (Opcion > 0) and (Opcion < 4) then 
		For Each f1 in fc

			NombreApli= ""

			If right(f1.name, 4) = ".apk" then

				rem	Establecemos el nombre de la aplicacion
				If InStr(f1.name, "-")>0 then
					NombreApli = left(f1.name, InStr(f1.name, "-")-1)
				Else
					NombreApli = left(f1.name, len(f1.name)-4)
				End If

	
				wscript.StdOut.write NombreApli &":" & VbNewLine

				rem	Tanto si elegimos la opcion 1 o la 3 deberemos instalar la aplicacion
				If (Opcion = 1) or (Opcion = 3) then

					comando= oshell.run("cmd /C "& SDK &"\adb install "& f1 &" > bin\resultado.txt", ventana, true)

					set file= fso.OpenTextFile("bin\resultado.txt", 1)
					archivo = file.ReadAll
					file.close
			
					If (InStr(archivo, "Failure")) then
						Failure = Failure+1
						If (InStr(archivo, "INSTALL_FAILED_ALREADY_EXISTS")) then
							YaExisten=YaExisten+1
							wscript.StdOut.write VbTab &"NO"& VbTab &"La aplicacin ya est instalada" & VbNewLine
						End If
					Else 
						If (InStr(archivo, "Success")) then
							Success= Success+1
							wscript.StdOut.write VbTab &"OK"& VbTab &"Aplicacin instalada" & VbNewLine
						End If
					End If
		
				End If


				For each f2 in fd

					If InStr(f2.name, "-")>0 then
						NombreFolder = left(f2.name, InStr(f2.name, "-")-1)
					Else
						NombreFolder = f2.name 
					End If

					If (NombreFolder = NombreApli) and ((Opcion = 2) or (Opcion = 3)) then
						comando= oshell.run("cmd /C "& SDK &"\adb push "& f2 &" /", ventana, true)
						wscript.StdOut.write VbTab &"OK"& VbTab &"Datos restaurados" & VbNewLine
						comando= oshell.run("cmd /C "& SDK &"\adb shell fix_permissions -f "& NombreApli, ventana, true)
						wscript.StdOut.write VbTab &"OK"& VbTab &"Permisos restaurados" & VbNewLine
						cont2=cont2+1
					End If

	
				Next
	
				cont = cont + 1
				Porcentaje = Cint((cont/NumAplis)*100)
				wscript.StdOut.Write VbTab & cont &" de "& NumAplis &" -> "& Porcentaje &"%"& VbNewLine & VbNewLine
			End If	

		Next

		wscript.StdOut.write "RESUMEN:" & VbNewLine
		if ((opcion=1) or (opcion=3)) Then
			wscript.StdOut.write VbTab & Success & " aplicaciones instaladas correctamente."& VbNewLine
			wscript.StdOut.write VbTab & Failure & " aplicaciones no instaladas."& VbNewLine
			wscript.StdOut.write VbTab & YaExisten&" aplicaciones ya estaban instaladas."& VbNewLine
		End If
		If ((opcion=2) or (opcion=3)) Then
			wscript.StdOut.write VbTab & cont2 & " datos de aplicaciones restaurados."& VbNewLine
		End If

	End If


Else
	wscript.StdOut.write VbNewLine &"No se ha encontrado ningn dispositivo. Por favor conecte uno."& VbNewLine
End If

set file= fso.GetFile("bin\resultado.txt")
file.Delete

Set fso = Nothing
Set oshell = Nothing


